<?

class STATS {

	var $product = null;
	var $edition = null;
	var $version = null;
	var $uptime = null;

	var $bps_in = 0;
	var $bps_out = 0;
	var $ssl_bps_in = 0;
	var $ssl_bps_out = 0;

	var $max_conn = 0;
	var $max_ssl_conn = 0;

	var $plain_conn = 0;
	var $avail_conn = 0;
	var $idle_conn = 0;

	var $ssl_conn = 0;
	var $avail_ssl_conn = 0;


	var $vhosts = array();
	var $load_avg = NULL;
	var $process_stats = array();
	var $cpu_avg = 0;
	var $ram_usage = NULL;
	
	var $mp;
	var $vm;

	//misc settings

	//full path to .rtreports files. different products have different paths
	var $report_path = "/tmp/lshttpd/";

	//processes..enterprise version can spawn proccess = cpu cores
	var $processes = 1;

	function &singleton() {
		static $instance;

		if (!isset($instance)) {
			$c = __CLASS__;
			$instance = new $c();
			$instance->init(); //there is php4 bug where constructor is not called..so workaround..call init()

		}

		return $instance;
	}


	function init() {

		$product = PRODUCT::singleton();


		$this->report_path = $product->tmp_path;
		$this->processes = $product->processes;

	
	}

	function parse_sysstat() {

		$product = PRODUCT::singleton();
		
		$lines = file($this->report_path . ".sysstats");

		$MPSTAT = '';
		$VMSTAT = '';
		$UPTIME = '';

		$PS = '';
		$cur = '';
		$tags = array('MPSTAT', 'VMSTAT', 'UPTIME', 'PS');

		$this->process_stats = array();


		foreach($lines as $line)
		{
			$line1 = rtrim($line);
			if ( in_array($line1, $tags) ) {
				$cur = $line1;
			}
			else
			{
				if ( $cur != 'PS' )
				{
					$$cur .= $line;
				}
				else
				{
					if ( strpos( $line, 'PID' ) === false )
					{
						$parsed = preg_split('/\s/', $line, -1, PREG_SPLIT_NO_EMPTY);

						$this->process_stats[count($this->process_stats)] = new STATS_PROCESS();

						$temp = &$this->process_stats[count($this->process_stats)-1];

						$temp->pid = $parsed[0];
						$temp->nice = $parsed[1];
						$temp->priority = $parsed[2];
						$temp->pcpu = $parsed[3];
						$temp->pmem = $parsed[4];
						$temp->rss = $parsed[5];
						$temp->vm = $parsed[6];
						$temp->tcpu = $parsed[7];

						$this->cpu_avg += $parsed[3];


						if($this->ram_usage == NULL) {
							$this->ram_usage = (int) $parsed[5];
						}
						else{
							$this->ram_usage += (int) $parsed[5];
						}

					}
				}
			}
		}

		$this->cpu_avg = $this->cpu_avg / count($this->process_stats);

		$pos = strpos( $MPSTAT, "\n");
		$MPSTAT = substr($MPSTAT, $pos+1);
		$this->mp = $MPSTAT;
		$this->vm = trim($VMSTAT);
		//$this->uptime = trim($UPTIME);

		$UPTIME = strtolower( $UPTIME );
		$pos = strpos($UPTIME, "load average");
		if ( $pos > 0 )
		{
			$pos += 13;
			if ( $UPTIME[$pos] == ':' )
				++$pos;
			$this->load_avg = trim(substr($UPTIME, $pos ));
		}
	}


	function parse_litespeed() {

		for ( $i = 1 ; $i <= $this->processes ; $i++ )
		{

			if ( $i > 1 ) {
				$content = file_get_contents("{$this->report_path}.rtreport.{$i}");
			}
			else {
				$content = file_get_contents("{$this->report_path}.rtreport");
			}

			$result = array();

			$found = 0;

			$found = preg_match_all("/VERSION: ([a-zA-Z0-9\ ]+)\/([a-zA-Z]*)\/([a-zA-Z0-9\.]+)\nUPTIME: ([0-9A-Za-z\ \:]+)\nBPS_IN:([0-9\ ]+), BPS_OUT:([0-9\ ]+), SSL_BPS_IN:([0-9\ ]+), SSL_BPS_OUT:([0-9\ ]+)\nMAXCONN:([0-9\ ]+), MAXSSL_CONN:([0-9\ ]+), PLAINCONN:([0-9\ ]+), AVAILCONN:([0-9\ ]+), IDLECONN:([0-9\ ]+), SSLCONN:([0-9\ ]+), AVAILSSL:([0-9\ ]+)/i", $content, $result);

			if($found == 1) {
				$this->product = trim($result[1][0]);
				$this->edition = trim($result[2][0]);
				$this->version = trim($result[3][0]);
				$this->uptime = trim($result[4][0]);
				$this->bps_in += (int) $result[5][0];
				$this->bps_out += (int) $result[6][0];
				$this->ssl_bps_in += (int) $result[7][0];
				$this->ssl_bps_out += (int) $result[8][0];

				$this->max_conn += (int) $result[9][0];
				$this->max_ssl_conn += (int) $result[10][0];

				$this->plain_conn += (int) $result[11][0];
				$this->avail_conn += (int) $result[12][0];
				$this->idle_conn += (int) $result[13][0];

				$this->ssl_conn += (int) $result[14][0];
				$this->avail_ssl_conn += (int) $result[15][0];
			}


			$result = array();
			$found = 0;

			$found = preg_match_all("/REQ_RATE \[([^\]]*)\]: REQ_PROCESSING: ([0-9]+), REQ_PER_SEC: ([0-9]+), TOT_REQS: ([0-9]+)/i",$content,$result);

			for($f = 0; $f < $found; $f++) {
				$vhost = trim($result[1][$f]);

				if($vhost == "") {
					$vhost = "_Server";
				}

				if(!array_key_exists($vhost,$this->vhosts)) {
					$this->vhosts[$vhost] = new STATS_VHOST($vhost);
				}

				$temp = &$this->vhosts[$vhost];

				$temp->req_processing += (int) $result[2][$f];
				$temp->req_per_sec += (int) $result[3][$f];
				$temp->req_total += (int) $result[4][$f];

			}

			//reset
			$result = array();
			$found = 0;

			$found = preg_match_all("/EXTAPP \[([^\]]*)\] \[([^\]]*)\] \[([^\]]*)\]: CMAXCONN: ([0-9]+), EMAXCONN: ([0-9]+), POOL_SIZE: ([0-9]+), INUSE_CONN: ([0-9]+), IDLE_CONN: ([0-9]+), WAITQUE_DEPTH: ([0-9]+), REQ_PER_SEC: ([0-9]+), TOT_REQS: ([0-9]+)/i",$content,$result);

			for($f = 0; $f < $found; $f++) {
				$vhost = trim($result[2][$f]);
				$extapp = trim($result[3][$f]);

				if($vhost == "") {
					$vhost = "_Server";
				}

				if(!array_key_exists($vhost,$this->vhosts)) {
					$this->vhosts[$vhost] = new STATS_VHOST($vhost);
				}



				if(!array_key_exists($extapp,$this->vhosts[$vhost]->extapps)) {
					$this->vhosts[$vhost]->extapps[$extapp] = new STATS_VHOST_EXTAPP($extapp, $vhost);
				}

				$temp = &$this->vhosts[$vhost]->extapps[$extapp];

				$temp->type = trim($result[1][$f]);
				$temp->config_max_conn += (int) $result[4][$f];
				$temp->effect_max_conn += (int) $result[5][$f];
				$temp->pool_size += (int) $result[6][$f];
				$temp->inuse_conn += (int) $result[7][$f];
				$temp->idle_conn += (int) $result[8][$f];
				$temp->waitqueue_depth += (int) $result[9][$f];
				$temp->req_per_sec += (int) $result[10][$f];
				$temp->req_total += (int) $result[11][$f];

			}

		}



	}



}

class STATS_VHOST {

	var $vhost = null;
	var $req_processing = 0;
	var $req_per_sec = 0;
	var $req_total = 0;
	var $extapps = array();

	function STATS_VHOST($vhost = null) {
		$this->vhost = trim($vhost);
	}

}

class STATS_VHOST_EXTAPP {

	function STATS_VHOST_EXTAPP($extapp = null, $vhost = null) {
		$this->extapp = trim($extapp);
		$this->vhost = trim($vhost);
	}

	var $vhost = null;
	var $type = null;
	var $extapp = null;
	var $config_max_conn = 0;
	var $effect_max_conn = 0;
	var $pool_size = 0;
	var $inuse_conn = 0;
	var $idle_conn = 0;
	var $waitqueue_depth = 0;
	var $req_per_sec = 0;
	var $req_total = 0;

}

class STATS_PROCESS {

	var $pid;
	var $nice;
	var $priority;
	var $pcpu;
	var $pmem;
	var $rss;
	var $vm;
	var $tcpu;

}



?>