<?php

$lsapi_version = '4.8';		// LSAPI
$apcvers = "3.0.19";			// APC
$eaccvers = "0.9.5.3";		// eAccelerator
$xcvers = "1.2.2";			// XCache
$shvers = "0.9.24";			// Suhosin Extension
	
$php_version = DUtil::grab_input("any","php_version");
$installPath = DUtil::grab_input("any","installPath");

// Replace linebreaks in configuration input with spaces
$configureParams = str_replace(array("\r\n","\n","\r")," ",DUtil::grab_input("any","configureParams"));

// remove unused params: '--prefix=/usr/local' '--with-apxs2=/usr/local/apache/bin/apxs'
$pattern_unused[0] = '/\'?--prefix=[^ \']+\'? ?/';
$pattern_unused[1] = '/\'?--with-apxs[^ \']+\'? ?/';
$configureParams = preg_replace($pattern_unused, '', $configureParams);


$uniqueid = DUtil::grab_input("any","uniqueid", "float");
$useOpcode = DUtil::grab_input("any","useOpcode", "int");
$patchSuhosin = DUtil::grab_input("any","patchSuhosin", "int");
$patchMailHeader = DUtil::grab_input("any","patchMailHeader", "int");

$path_env = DUtil::grab_input("any", "path_env" );

$php_version = str_replace("/","",$php_version);
$installPath = str_replace("..","",$installPath);

$ocvers = ""; //init var before use
$ocname = "";

$php_version = (empty($php_version)) ? '5.2.5' : $php_version;

// Check for valid php version input
if (!is_numeric(str_replace('.','',$php_version)))
	$php_version = '5.2.5';
	
if (strpos($php_version,"5.") === 0)
	$php_base_version = 5;
else
	$php_base_version = 4;
	

$installPath = (empty($installPath)) ? $_SERVER['LS_SERVER_ROOT']."lsphp" . $php_base_version : $installPath;

$saveConfig = serialize(array($php_version,$installPath,$configureParams,$useOpcode,$patchSuhosin,$patchMailHeader));

$fh = @fopen($_SERVER['LS_SERVER_ROOT']."phpbuild/savedconfig.".$php_base_version.".txt",'w');
@fwrite($fh,$saveConfig);
@fclose($fh);


$buildscript = "#!/bin/sh\n";


// $uniqueid = time() . "." . rand(1,9);
$builddir = $_SERVER['LS_SERVER_ROOT']."phpbuild/phpbuild.".$uniqueid;

if (file_exists($builddir.".progress")) {
	echo "Please do not use the browser refresh, back and forward buttons on the PHP build pages. <a href='/utility/buildPHP.php'>Try again</a>.";
	exit;
}

//echo $builddir;

// Detect download method
$OS=`uname`;
$dlmethod = '';
if ( $OS == 'FreeBSD' )
{
    if ((exec('PATH=$path_env:/bin:/usr/bin:/usr/local/bin fetch', $o,$status)||1) && $status == 64)
        $dlmethod = "fetch";
}


if ( $dlmethod == '' )
{
    exec( 'PATH=$path_env:/bin:/usr/bin:/usr/local/bin which which', $o, $status);
    if ( $status == 0 )
    {
	if (strpos($which_curl = str_replace("\n","",`PATH=$path_env:/bin:/usr/bin:/usr/local/bin which curl`), "/") == 0)
	    $dlmethod = "curl";
	else if (strpos($which_wget = str_replace("\n","",`PATH=$path_env:/bin:/usr/bin:/usr/local/bin which wget`), "/") == 0)
	    $dlmethod = "wget";
	else if (strpos($which_fetch = str_replace("\n","",`PATH=$path_env:/bin:/usr/bin:/usr/local/bin which fetch`), "/") == 0)
	    $dlmethod = "fetch";
    }	
}

if ( $dlmethod == '' )
{
    if ( (exec('PATH=$path_env:/bin:/usr/bin:/usr/local/bin curl', $o, $status)||1) && $status <= 2)
	$dlmethod = "curl";
    else if ((exec( 'PATH=$path_env:/bin:/usr/bin:/usr/local/bin wget', $o, $status)|| 1) && $status <= 2 )
	$dlmethod = "wget";
    else {
	echo "ERROR: Unable to detect download method (install curl, fetch, or wget)";
	exit;
    }
}

// dlstring: Return method-appropriate download command
function dlstring($output,$url) {
	global $dlmethod, $which_curl, $which_fetch, $which_wget;
	switch ($dlmethod) {
		case 'curl': return "curl -L -o $output $url\n";
		case 'fetch': return "fetch -o $output $url\n";
		case 'wget': return "wget -O $output $url\n";
	}
}



if ( isset( $path_env )&&( $path_env != "" ))
    $buildscript .= "PATH=".$path_env.":\$PATH\n";
$buildscript .= "check_errs()\n";
$buildscript .= "{\n";
$buildscript .= "  if [ \"\${1}\" -ne \"0\" ]; then\n";
$buildscript .= "    echo \"ERROR \${2}\" > ".$builddir.".progress\n";
$buildscript .= "    exit \${1}\n";
$buildscript .= "  fi\n";
$buildscript .= "}\n\n";

$buildscript .= "echo \"Changing to build directory\" > ".$builddir.".progress\n";
$buildscript .= "cd ".$_SERVER['LS_SERVER_ROOT']."phpbuild\n";
$buildscript .= "check_errs \$? \"Could not get into build directory\"\n";
$buildscript .= "rm -rf php-".$php_version."\n";
$buildscript .= "check_errs \$? \"Could not delete old php directory\"\n";

if (!file_exists($_SERVER['LS_SERVER_ROOT']."phpbuild/php-".$php_version.".tar.gz")) {
	$buildscript .= "echo \"Retrieving PHP source archive\" > ".$builddir.".progress\n";
	$buildscript .= dlstring("php-".$php_version.".tar.gz","http://us.php.net/get/php-".$php_version.".tar.gz/from/us2.php.net/mirror");
	$buildscript .= "check_errs \$? \"Could not retrieve PHP source archive\"\n";
}

$buildscript .= "echo \"Extracting PHP source archive\" > ".$builddir.".progress\n";
$buildscript .= "tar -zxf php-".$php_version.".tar.gz\n";
$buildscript .= "check_errs \$? \"Could not extract PHP source archive\"\n";



if ($patchSuhosin == 1) {
	$buildscript .= "echo \"Retrieving Suhosin patch\" > ".$builddir.".progress\n";
	if ($php_base_version == 4) {
		$buildscript .= dlstring("suhosin-patch-".$php_version.".patch.gz","http://download.suhosin.org/suhosin-patch-".$php_version."-0.9.6.patch.gz");
	} else {
		$buildscript .= dlstring("suhosin-patch-".$php_version.".patch.gz","http://download.suhosin.org/suhosin-patch-".$php_version."-0.9.6.2.patch.gz");
	}
	$buildscript .= "check_errs \$? \"Could not retrieve Suhosin patch\"\n";
	
	$buildscript .= "echo \"Extracting Suhosin patch\" > ".$builddir.".progress\n";
	$buildscript .= "gunzip -f suhosin-patch-".$php_version.".patch.gz\n";
	$buildscript .= "check_errs \$? \"Could not extract Suhosin patch\"\n";
	
	$buildscript .= "echo \"Patching source with Suhosin patch\" > ".$builddir.".progress\n";
	$buildscript .= "patch -p0 < suhosin-patch-".$php_version.".patch\n";
	$buildscript .= "check_errs \$? \"Could not patch source with Suhosin patch\"\n";
	$configureParams .= " --enable-suhosin";
	
	$shbuildscript = "";
	if ( isset( $path_env )&&( $path_env != "" ))
	    $shbuildscript .= "PATH=".$path_env.":\$PATH\n";
	
	$shbuildscript .= "check_errs()\n";
	$shbuildscript .= "{\n";
	$shbuildscript .= "  if [ \"\${1}\" -ne \"0\" ]; then\n";
	$shbuildscript .= "    echo \"ERROR \${2}\" > ".$builddir.".progress\n";
	$shbuildscript .= "    exit \${1}\n";
	$shbuildscript .= "  fi\n";
	$shbuildscript .= "}\n\n";
	
	$shbuildscript .= "echo \"Changing to PHP directory\" > ".$builddir.".progress\n";
	$shbuildscript .= "cd ".$_SERVER['LS_SERVER_ROOT']."phpbuild/php-".$php_version."\n";
	$shbuildscript .= "check_errs \$? \"Could not change to PHP directory\"\n";
	
	//http://download.suhosin.org/suhosin-0.9.23.tgz
	
	if (!file_exists($_SERVER['LS_SERVER_ROOT']."phpbuild/suhosin-".$shvers.".tgz")) {
		$shbuildscript .= "echo \"Retrieving Suhosin extension source archive\" > ".$builddir.".progress\n";
		$shbuildscript .= dlstring("../suhosin-".$shvers.".tgz","http://download.suhosin.org/suhosin-".$shvers.".tgz");
		$shbuildscript .= "check_errs \$? \"Could not retrieve Suhosin extension source archive\"\n";
	}
	
	$shbuildscript .= "echo \"Copying Suhosin extension source archive\" > ".$builddir.".progress\n";
	$shbuildscript .= "cp ../suhosin-".$shvers.".tgz ./\n";
	$shbuildscript .= "check_errs \$? \"Could not copy Suhosin extension source archive\"\n";
	
	$shbuildscript .= "echo \"Extracting Suhosin extension source archive\" > ".$builddir.".progress\n";
	$shbuildscript .= "tar -zxf suhosin-".$shvers.".tgz\n";
	$shbuildscript .= "check_errs \$? \"Could not extract Suhosin extension source archive\"\n";
	
	$shbuildscript .= "echo \"Changing to Suhosin extension directory\" > ".$builddir.".progress\n";
	$shbuildscript .= "cd suhosin-".$shvers."\n";
	$shbuildscript .= "check_errs \$? \"Could not change to Suhosin extension directory\"\n";
	
	$shbuildscript .= "echo \"Running PHPize for Suhosin extension\" > ".$builddir.".progress\n";
	$shbuildscript .= $installPath."/bin/phpize\n";
	$shbuildscript .= "check_errs \$? \"Could not run PHPize for Suhosin\"\n";
	
	$shbuildscript .= "echo \"Configuring Suhosin extension build\" > ".$builddir.".progress\n";
	$shbuildscript .= "./configure --with-php-config=".$installPath."/bin/php-config\n";
	$shbuildscript .= "check_errs \$? \"Configuring Suhosin extension build\"\n";
	
	$shbuildscript .= "echo \"Compiling Suhosin extension\" > ".$builddir.".progress\n";
	$shbuildscript .= "make\n";
	$shbuildscript .= "check_errs \$? \"Could not compile Suhosin extension\"\n";
	
	$shbuildscript .= "echo \"Suhosin extension build complete\" > ".$builddir.".progress\n";
	
	if (!$shhandle = fopen($builddir.'sh.sh','w')) {
		echo "ERROR: Cannot open Suhosin extension build script";
		exit;
	}
	if (fwrite($shhandle,$shbuildscript) === FALSE) {
		echo "ERROR: Cannot write to Suhosin extension build script";
		exit;
	}
	fclose($shhandle);
	chmod($builddir.'sh.sh', 0755);
	
	
}

if ($patchMailHeader == 1) {
	// http://choon.net/opensource/php/php-4.4.8-mail-header.patch
	$buildscript .= "echo \"Retrieving mail header patch\" > ".$builddir.".progress\n";
	$buildscript .= dlstring("php-".$php_version."-mail-header.patch","http://choon.net/opensource/php/php-".$php_version."-mail-header.patch");
	$buildscript .= "check_errs \$? \"Could not retrieve mail header patch\"\n";
	
	$buildscript .= "echo \"Patching source with mail header patch\" > ".$builddir.".progress\n";
	$buildscript .= "patch -p0 < php-".$php_version."-mail-header.patch\n";
	$buildscript .= "check_errs \$? \"Could not patch source with mail header patch\"\n";
}

$buildscript .= "echo \"Retrieving LSAPI archive\" > ".$builddir.".progress\n";
$buildscript .= "cd php-".$php_version."/sapi\n";
$buildscript .= "check_errs \$? \"Could not get into php/sapi directory\"\n";
$buildscript .= dlstring("php-litespeed-".$lsapi_version.".tgz","http://www.litespeedtech.com/packages/lsapi/php-litespeed-".$lsapi_version.".tgz");
$buildscript .= "check_errs \$? \"Could not retrieve LSAPI archive\"\n";


$buildscript .= "echo \"Extracting LSAPI archive\" > ".$builddir.".progress\n";
$buildscript .= "tar -xzf php-litespeed-".$lsapi_version.".tgz\n";
$buildscript .= "check_errs \$? \"Could not extract LSAPI archive\"\n";

$buildscript .= "echo \"Generating configuration script\" > ".$builddir.".progress\n";
$buildscript .= "cd ..\n";
$buildscript .= "check_errs \$? \"Could not get into php directory\"\n";
$buildscript .= "touch ac*\n";
$buildscript .= "check_errs \$? \"Could not touch ac*\"\n";
$buildscript .= "./buildconf --force\n";
$buildscript .= "check_errs \$? \"Could not generate configuration script\"\n";

$buildscript .= "echo \"Configuring PHP build (2-3 minutes)\" > ".$builddir.".progress\n";
$cmd = "./configure '--prefix=".$installPath."' '--with-litespeed' ".escapeshellcmd($configureParams)."\n";

//$buildscript .= "echo \"".$cmd."\" >> ".$builddir.".log\n";

$buildscript .= "./configure '--prefix=".$installPath."' '--with-litespeed' ".escapeshellcmd($configureParams)."\n";
$buildscript .= "check_errs \$? \"Could not configure PHP build\"\n";

$buildscript .= "echo \"Compiling PHP (5-10 minutes)\" > ".$builddir.".progress\n";
$buildscript .= "make\n";
$buildscript .= "check_errs \$? \"Could not compile PHP\"\n";

if ($useOpcode == "1") {
	// APC
	// http://pecl.php.net/get/APC-3.0.15.tgz

	$ocvers = "APC-" . $apcvers;
	$ocname = "APC";
	$ocbuildscript = "";
	
	if ( isset( $path_env )&&( $path_env != "" ))
	    $ocbuildscript .= "PATH=".$path_env.":\$PATH\n";

	$ocbuildscript .= "check_errs()\n";
	$ocbuildscript .= "{\n";
	$ocbuildscript .= "  if [ \"\${1}\" -ne \"0\" ]; then\n";
	$ocbuildscript .= "    echo \"ERROR \${2}\" > ".$builddir.".progress\n";
	$ocbuildscript .= "    exit \${1}\n";
	$ocbuildscript .= "  fi\n";
	$ocbuildscript .= "}\n\n";
	
	$ocbuildscript .= "echo \"Changing to PHP directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$_SERVER['LS_SERVER_ROOT']."phpbuild/php-".$php_version."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to PHP directory\"\n";
	
	if (!file_exists($_SERVER['LS_SERVER_ROOT']."phpbuild/".$ocvers.".tgz")) {
		$ocbuildscript .= "echo \"Retrieving APC source archive\" > ".$builddir.".progress\n";
		$ocbuildscript .= dlstring("../".$ocvers.".tgz","http://pecl.php.net/get/".$ocvers.".tgz");
		$ocbuildscript .= "check_errs \$? \"Could not retrieve APC source archive\"\n";
	}
	
	$ocbuildscript .= "echo \"Copying APC source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cp ../".$ocvers.".tgz ./\n";
	$ocbuildscript .= "check_errs \$? \"Could not copy APC source archive\"\n";
	
	$ocbuildscript .= "echo \"Extracting APC source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "tar -zxf ".$ocvers.".tgz\n";
	$ocbuildscript .= "check_errs \$? \"Could not extract APC source archive\"\n";
	
	$ocbuildscript .= "echo \"Changing to APC directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$ocvers."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to APC directory\"\n";
	
	$ocbuildscript .= "echo \"Running PHPize for APC\" > ".$builddir.".progress\n";
	$ocbuildscript .= $installPath."/bin/phpize\n";
	$ocbuildscript .= "check_errs \$? \"Could not run PHPize for APC\"\n";
	
	$ocbuildscript .= "echo \"Configuring APC build\" > ".$builddir.".progress\n";
	$ocbuildscript .= "./configure --enable-apc --with-php-config=".$installPath."/bin/php-config\n";
	$ocbuildscript .= "check_errs \$? \"Configuring APC build\"\n";
	
	$ocbuildscript .= "echo \"Compiling APC\" > ".$builddir.".progress\n";
	$ocbuildscript .= "make\n";
	$ocbuildscript .= "check_errs \$? \"Could not compile APC\"\n";
	
	$ocbuildscript .= "echo \"PHP and opcode cache build complete\" > ".$builddir.".progress\n";
	
	if (!$ochandle = fopen($builddir.'oc.sh','w')) {
		echo "ERROR: Cannot open opcode build script";
		exit;
	}
	if (fwrite($ochandle,$ocbuildscript) === FALSE) {
		echo "ERROR: Cannot write to opcode build script";
		exit;
	}
	fclose($ochandle);
	chmod($builddir.'oc.sh', 0755);
	
} elseif ($useOpcode == "2") {
	// eAccelerator
	// http://superb-east.dl.sourceforge.net/sourceforge/eaccelerator/eaccelerator-0.9.5.2.tar.bz2
	
	$ocvers = "eaccelerator-" . $eaccvers;
	$ocname = "eAccelerator";
	$ocbuildscript = "";

	if ( isset( $path_env )&&( $path_env != "" ))
	    $ocbuildscript .= "PATH=".$path_env.":\$PATH\n";
	
	$ocbuildscript .= "check_errs()\n";
	$ocbuildscript .= "{\n";
	$ocbuildscript .= "  if [ \"\${1}\" -ne \"0\" ]; then\n";
	$ocbuildscript .= "    echo \"ERROR \${2}\" > ".$builddir.".progress\n";
	$ocbuildscript .= "    exit \${1}\n";
	$ocbuildscript .= "  fi\n";
	$ocbuildscript .= "}\n\n";
	
	$ocbuildscript .= "echo \"Changing to PHP directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$_SERVER['LS_SERVER_ROOT']."phpbuild/php-".$php_version."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to PHP directory\"\n";
	
	if (!file_exists($_SERVER['LS_SERVER_ROOT']."phpbuild/".$ocvers.".tar.bz2")) {
		$ocbuildscript .= "echo \"Retrieving eAccelerator source archive\" > ".$builddir.".progress\n";
		$ocbuildscript .= dlstring("../".$ocvers.".tar.bz2","http://bart.eaccelerator.net/source/$eaccvers/$ocvers.tar.bz2");
		$ocbuildscript .= "check_errs \$? \"Could not retrieve eAccelerator source archive\"\n";
	}
	
	$ocbuildscript .= "echo \"Copying eAccelerator source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cp ../".$ocvers.".tar.bz2 ./\n";
	$ocbuildscript .= "check_errs \$? \"Could not copy eAccelerator source archive\"\n";
	
	$ocbuildscript .= "echo \"Extracting eAccelerator source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "tar -jxf ".$ocvers.".tar.bz2\n";
	$ocbuildscript .= "check_errs \$? \"Could not extract eAccelerator source archive\"\n";
	
	$ocbuildscript .= "echo \"Changing to eAccelerator directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$ocvers."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to eAccelerator directory\"\n";
	
	$ocbuildscript .= "echo \"Running PHPize for eAccelerator\" > ".$builddir.".progress\n";
	$ocbuildscript .= $installPath."/bin/phpize\n";
	$ocbuildscript .= "check_errs \$? \"Could not run PHPize for eAccelerator\"\n";
	
	$ocbuildscript .= "echo \"Configuring eAccelerator build\" > ".$builddir.".progress\n";
	$ocbuildscript .= "./configure --enable-eaccelerator=shared --with-php-config=".$installPath."/bin/php-config\n";
	$ocbuildscript .= "check_errs \$? \"Configuring eAccelerator build\"\n";
	
	$ocbuildscript .= "echo \"Compiling eAccelerator\" > ".$builddir.".progress\n";
	$ocbuildscript .= "make\n";
	$ocbuildscript .= "check_errs \$? \"Could not compile eAccelerator\"\n";
	
	$ocbuildscript .= "echo \"PHP and opcode cache build complete\" > ".$builddir.".progress\n";
	
	if (!$ochandle = fopen($builddir.'oc.sh','w')) {
		echo "ERROR: Cannot open opcode build script";
		exit;
	}
	if (fwrite($ochandle,$ocbuildscript) === FALSE) {
		echo "ERROR: Cannot write to opcode build script";
		exit;
	}
	fclose($ochandle);
	chmod($builddir.'oc.sh', 0755);
} elseif ($useOpcode == "3") {
	// XCache
	// http://xcache.lighttpd.net/pub/Releases/1.2.1/xcache-1.2.1.tar.gz
	
	$ocvers = "xcache-" . $xcvers;
	$ocname = "XCache";
	$ocbuildscript = "";

	if ( isset( $path_env )&&( $path_env != "" ))
	    $ocbuildscript .= "PATH=".$path_env.":\$PATH\n";
	
	$ocbuildscript .= "check_errs()\n";
	$ocbuildscript .= "{\n";
	$ocbuildscript .= "  if [ \"\${1}\" -ne \"0\" ]; then\n";
	$ocbuildscript .= "    echo \"ERROR \${2}\" > ".$builddir.".progress\n";
	$ocbuildscript .= "    exit \${1}\n";
	$ocbuildscript .= "  fi\n";
	$ocbuildscript .= "}\n\n";
	
	$ocbuildscript .= "echo \"Changing to PHP directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$_SERVER['LS_SERVER_ROOT']."phpbuild/php-".$php_version."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to PHP directory\"\n";
	
	if (!file_exists($_SERVER['LS_SERVER_ROOT']."phpbuild/".$ocvers.".tar.gz")) {
		$ocbuildscript .= "echo \"Retrieving XCache source archive\" > ".$builddir.".progress\n";
		$ocbuildscript .= dlstring("../".$ocvers.".tar.gz","http://xcache.lighttpd.net/pub/Releases/".$xcvers."/".$ocvers.".tar.gz");
		$ocbuildscript .= "check_errs \$? \"Could not retrieve XCache source archive\"\n";
	}
	
	$ocbuildscript .= "echo \"Copying XCache source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cp ../".$ocvers.".tar.gz ./\n";
	$ocbuildscript .= "check_errs \$? \"Could not copy XCache source archive\"\n";
	
	$ocbuildscript .= "echo \"Extracting XCache source archive\" > ".$builddir.".progress\n";
	$ocbuildscript .= "tar -zxf ".$ocvers.".tar.gz\n";
	$ocbuildscript .= "check_errs \$? \"Could not extract XCache source archive\"\n";
	
	$ocbuildscript .= "echo \"Changing to XCache directory\" > ".$builddir.".progress\n";
	$ocbuildscript .= "cd ".$ocvers."\n";
	$ocbuildscript .= "check_errs \$? \"Could not change to XCache directory\"\n";
	
	$ocbuildscript .= "echo \"Running PHPize for XCache\" > ".$builddir.".progress\n";
	$ocbuildscript .= $installPath."/bin/phpize\n";
	$ocbuildscript .= "check_errs \$? \"Could not run PHPize for XCache\"\n";
	
	$ocbuildscript .= "echo \"Configuring XCache build\" > ".$builddir.".progress\n";
	$ocbuildscript .= "./configure --enable-xcache --with-php-config=".$installPath."/bin/php-config\n";
	$ocbuildscript .= "check_errs \$? \"Configuring XCache build\"\n";
	
	$ocbuildscript .= "echo \"Compiling XCache\" > ".$builddir.".progress\n";
	$ocbuildscript .= "make\n";
	$ocbuildscript .= "check_errs \$? \"Could not compile XCache\"\n";
	
	$ocbuildscript .= "echo \"PHP and opcode cache build complete\" > ".$builddir.".progress\n";
	
	if (!$ochandle = fopen($builddir.'oc.sh','w')) {
		echo "ERROR: Cannot open opcode build script";
		exit;
	}
	if (fwrite($ochandle,$ocbuildscript) === FALSE) {
		echo "ERROR: Cannot write to opcode build script";
		exit;
	}
	fclose($ochandle);
	chmod($builddir.'oc.sh', 0755);
}

$buildscript .= "echo \"PHP build complete\" > ".$builddir.".progress\n";

//echo $builddir;
if (!$handle = fopen($builddir.'.sh','w')) {
	echo "ERROR: Cannot open build script";
	exit;
}
if (fwrite($handle,$buildscript) === FALSE) {
	echo "ERROR: Cannot write to build script";
	exit;
}
fclose($handle);
chmod($builddir.'.sh', 0755);
exec ("bash -c \"exec nohup ".escapeshellcmd($builddir).'.sh'." 1>".escapeshellcmd($builddir).".log 2>&1 &\"");

?>

<script>
var xhr;

function getUpdate() {
  try { xhr = new XMLHttpRequest(); }
  catch(e)
  {
    xhr = new ActiveXObject(Microsoft.XMLHTTP);
  }

  xhr.abort();
  xhr.open("GET", "/utility/buildPHPProgress.php?id=<?=$uniqueid?>&vers=<?=$php_version?>&ocvers=<?=$ocvers?>&ocname=<?=$ocname?>&shvers=<?=$shvers?>", true);
  xhr.send(null);


  xhr.onreadystatechange = function()
  {
    if(xhr.readyState == 4)
    {
      if(xhr.status == 200)
      {
        document.getElementById("statuszone").innerHTML = xhr.responseText;
        if (xhr.responseText.indexOf("complete")==-1 && xhr.responseText.indexOf("ERROR")==-1)
            setTimeout("getUpdate();", 600);
		  else	
		  {
			document.getElementById("statusgzone").innerHTML = "(<a href='buildPHP.php?viewlog=<?=$uniqueid?>&vers=<?=$php_version?>'>View Log</a>)";
			if (xhr.responseText.indexOf("opcode") > -1 && xhr.responseText.indexOf("complete") > -1)
				document.getElementById("statusgzone").innerHTML = document.getElementById("statusgzone").innerHTML + "<br><br>To enable the <?=$ocname?> opcode cache, please add the following to the end of your php.ini configuration file. In addition, you may need to use the View Log link above to determine the directory where your extensions are installed and add the directory to the extensions path in your php.ini configuration file.<br><br> <?
				
function nl2br2($string) {
	$string = str_replace(array("\r\n", "\r", "\n"), "<br />", $string);
	return $string;
}		
		
switch ($ocname) {

case 'eAccelerator':
echo nl2br2('extension=\"eaccelerator.so\"
eaccelerator.shm_size=\"16\"
eaccelerator.cache_dir=\"/tmp/eaccelerator\"
eaccelerator.enable=\"1\"
eaccelerator.optimizer=\"1\"
eaccelerator.check_mtime=\"1\"
eaccelerator.debug=\"0\"
eaccelerator.filter=\"\"
eaccelerator.shm_max=\"0\"
eaccelerator.shm_ttl=\"0\"
eaccelerator.shm_prune_period=\"0\"
eaccelerator.shm_only=\"0\"
eaccelerator.compress=\"1\"
eaccelerator.compress_level=\"9\"');
break;

case 'APC':
echo nl2br2('extension=apc.so');
break;

case 'XCache':
echo nl2br2('extension=xcache.so');
break;	
	
} ?>";

if (xhr.responseText.indexOf("Suhosin") > -1 && xhr.responseText.indexOf("complete") > -1)
	document.getElementById("statusgzone").innerHTML = document.getElementById("statusgzone").innerHTML + "<br><br>To enable the Suhosin extension, please add the following to the end of your php.ini configuration file. In addition, you may need to use the View Log link above to determine the directory where your extensions are installed and add the directory to the extensions path in your php.ini configuration file.<br><br>extension=suhosin.so<br>";
		  }
      }
      else
	  {
        document.getElementById("statuszone").innerHTML + " (" + document.getElementById("statuszone").innerHTML + "Status update refresh error " + xhr.status + "... please wait)";
		setTimeout("getUpdate();", 600);
      }
    }
  };
}

getUpdate();

</script>

<h2>Compile PHP</h2>

<table width="100%" class="xtbl" border="0" cellpadding="5" cellspacing="1">
	<tr class="xtbl_header">
		<td colspan="3" class="xtbl_title">
		PHP Build Progress
		</td>
	</tr>
	<tr class="xtbl_value">
		<td class="xtbl_label">Status</td>
		<td class="icon"></td>
		<td>
			<div id="statuszone">Starting...</div>
			<div id="statusgzone"><img src='/static/images/working.gif'></div>
		</td>
	</tr>
</table>


